git-rebase.shon commit Merge branch 'jc/skip-count' (d4ada48)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .dotest working files, use the command
  18git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.  You must be in the top
  22directory of your project to start (or continue) a rebase.
  23
  24Example:       git-rebase master~1 topic
  25
  26        A---B---C topic                   A'\''--B'\''--C'\'' topic
  27       /                   -->           /
  28  D---E---F---G master          D---E---F---G master
  29'
  30. git-sh-setup
  31
  32RESOLVEMSG="
  33When you have resolved this problem run \"git rebase --continue\".
  34If you would prefer to skip this patch, instead run \"git rebase --skip\".
  35To restore the original branch and stop rebasing run \"git rebase --abort\".
  36"
  37unset newbase
  38strategy=recursive
  39do_merge=
  40dotest=$GIT_DIR/.dotest-merge
  41prec=4
  42verbose=
  43
  44continue_merge () {
  45        test -n "$prev_head" || die "prev_head must be defined"
  46        test -d "$dotest" || die "$dotest directory does not exist"
  47
  48        unmerged=$(git-ls-files -u)
  49        if test -n "$unmerged"
  50        then
  51                echo "You still have unmerged paths in your index"
  52                echo "did you forget update-index?"
  53                die "$RESOLVEMSG"
  54        fi
  55
  56        if test -n "`git-diff-index HEAD`"
  57        then
  58                if ! git-commit -C "`cat $dotest/current`"
  59                then
  60                        echo "Commit failed, please do not call \"git commit\""
  61                        echo "directly, but instead do one of the following: "
  62                        die "$RESOLVEMSG"
  63                fi
  64                printf "Committed: %0${prec}d" $msgnum
  65        else
  66                printf "Already applied: %0${prec}d" $msgnum
  67        fi
  68        echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
  69                                sed 's/^[a-f0-9]\+ //'`
  70
  71        prev_head=`git-rev-parse HEAD^0`
  72        # save the resulting commit so we can read-tree on it later
  73        echo "$prev_head" > "$dotest/prev_head"
  74
  75        # onto the next patch:
  76        msgnum=$(($msgnum + 1))
  77        echo "$msgnum" >"$dotest/msgnum"
  78}
  79
  80call_merge () {
  81        cmt="$(cat $dotest/cmt.$1)"
  82        echo "$cmt" > "$dotest/current"
  83        git-merge-$strategy "$cmt^" -- HEAD "$cmt"
  84        rv=$?
  85        case "$rv" in
  86        0)
  87                return
  88                ;;
  89        1)
  90                test -d "$GIT_DIR/rr-cache" && git-rerere
  91                die "$RESOLVEMSG"
  92                ;;
  93        2)
  94                echo "Strategy: $rv $strategy failed, try another" 1>&2
  95                die "$RESOLVEMSG"
  96                ;;
  97        *)
  98                die "Unknown exit code ($rv) from command:" \
  99                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 100                ;;
 101        esac
 102}
 103
 104finish_rb_merge () {
 105        rm -r "$dotest"
 106        echo "All done."
 107}
 108
 109while case "$#" in 0) break ;; esac
 110do
 111        case "$1" in
 112        --continue)
 113                diff=$(git-diff-files)
 114                case "$diff" in
 115                ?*)     echo "You must edit all merge conflicts and then"
 116                        echo "mark them as resolved using git update-index"
 117                        exit 1
 118                        ;;
 119                esac
 120                if test -d "$dotest"
 121                then
 122                        prev_head="`cat $dotest/prev_head`"
 123                        end="`cat $dotest/end`"
 124                        msgnum="`cat $dotest/msgnum`"
 125                        onto="`cat $dotest/onto`"
 126                        continue_merge
 127                        while test "$msgnum" -le "$end"
 128                        do
 129                                call_merge "$msgnum"
 130                                continue_merge
 131                        done
 132                        finish_rb_merge
 133                        exit
 134                fi
 135                git am --resolved --3way --resolvemsg="$RESOLVEMSG" \
 136                        --reflog-action=rebase
 137                exit
 138                ;;
 139        --skip)
 140                if test -d "$dotest"
 141                then
 142                        if test -d "$GIT_DIR/rr-cache"
 143                        then
 144                                git-rerere clear
 145                        fi
 146                        prev_head="`cat $dotest/prev_head`"
 147                        end="`cat $dotest/end`"
 148                        msgnum="`cat $dotest/msgnum`"
 149                        msgnum=$(($msgnum + 1))
 150                        onto="`cat $dotest/onto`"
 151                        while test "$msgnum" -le "$end"
 152                        do
 153                                call_merge "$msgnum"
 154                                continue_merge
 155                        done
 156                        finish_rb_merge
 157                        exit
 158                fi
 159                git am -3 --skip --resolvemsg="$RESOLVEMSG" \
 160                        --reflog-action=rebase
 161                exit
 162                ;;
 163        --abort)
 164                if test -d "$GIT_DIR/rr-cache"
 165                then
 166                        git-rerere clear
 167                fi
 168                if test -d "$dotest"
 169                then
 170                        rm -r "$dotest"
 171                elif test -d .dotest
 172                then
 173                        rm -r .dotest
 174                else
 175                        die "No rebase in progress?"
 176                fi
 177                git reset --hard ORIG_HEAD
 178                exit
 179                ;;
 180        --onto)
 181                test 2 -le "$#" || usage
 182                newbase="$2"
 183                shift
 184                ;;
 185        -M|-m|--m|--me|--mer|--merg|--merge)
 186                do_merge=t
 187                ;;
 188        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 189                --strateg=*|--strategy=*|\
 190        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 191                case "$#,$1" in
 192                *,*=*)
 193                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 194                1,*)
 195                        usage ;;
 196                *)
 197                        strategy="$2"
 198                        shift ;;
 199                esac
 200                do_merge=t
 201                ;;
 202        -v|--verbose)
 203                verbose=t
 204                ;;
 205        -*)
 206                usage
 207                ;;
 208        *)
 209                break
 210                ;;
 211        esac
 212        shift
 213done
 214
 215# Make sure we do not have .dotest
 216if test -z "$do_merge"
 217then
 218        if mkdir .dotest
 219        then
 220                rmdir .dotest
 221        else
 222                echo >&2 '
 223It seems that I cannot create a .dotest directory, and I wonder if you
 224are in the middle of patch application or another rebase.  If that is not
 225the case, please rm -fr .dotest and run me again.  I am stopping in case
 226you still have something valuable there.'
 227                exit 1
 228        fi
 229else
 230        if test -d "$dotest"
 231        then
 232                die "previous dotest directory $dotest still exists." \
 233                        'try git-rebase < --continue | --abort >'
 234        fi
 235fi
 236
 237# The tree must be really really clean.
 238git-update-index --refresh || exit
 239diff=$(git-diff-index --cached --name-status -r HEAD)
 240case "$diff" in
 241?*)     echo "$diff"
 242        exit 1
 243        ;;
 244esac
 245
 246# The upstream head must be given.  Make sure it is valid.
 247upstream_name="$1"
 248upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 249    die "invalid upstream $upstream_name"
 250
 251# If a hook exists, give it a chance to interrupt
 252if test -x "$GIT_DIR/hooks/pre-rebase"
 253then
 254        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 255                echo >&2 "The pre-rebase hook refused to rebase."
 256                exit 1
 257        }
 258fi
 259
 260# If the branch to rebase is given, first switch to it.
 261case "$#" in
 2622)
 263        branch_name="$2"
 264        git-checkout "$2" || usage
 265        ;;
 266*)
 267        branch_name=`git symbolic-ref HEAD` || die "No current branch"
 268        branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 269        ;;
 270esac
 271branch=$(git-rev-parse --verify "${branch_name}^0") || exit
 272
 273# Make sure the branch to rebase onto is valid.
 274onto_name=${newbase-"$upstream_name"}
 275onto=$(git-rev-parse --verify "${onto_name}^0") || exit
 276
 277# Now we are rebasing commits $upstream..$branch on top of $onto
 278
 279# Check if we are already based on $onto, but this should be
 280# done only when upstream and onto are the same.
 281mb=$(git-merge-base "$onto" "$branch")
 282if test "$upstream" = "$onto" && test "$mb" = "$onto"
 283then
 284        echo >&2 "Current branch $branch_name is up to date."
 285        exit 0
 286fi
 287
 288if test -n "$verbose"
 289then
 290        echo "Changes from $mb to $onto:"
 291        git-diff-tree --stat --summary "$mb" "$onto"
 292fi
 293
 294# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
 295echo "First, rewinding head to replay your work on top of it..."
 296git-reset --hard "$onto"
 297
 298# If the $onto is a proper descendant of the tip of the branch, then
 299# we just fast forwarded.
 300if test "$mb" = "$branch"
 301then
 302        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 303        exit 0
 304fi
 305
 306if test -z "$do_merge"
 307then
 308        git-format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
 309        git am --binary -3 -k --resolvemsg="$RESOLVEMSG" \
 310                --reflog-action=rebase
 311        exit $?
 312fi
 313
 314# start doing a rebase with git-merge
 315# this is rename-aware if the recursive (default) strategy is used
 316
 317mkdir -p "$dotest"
 318echo "$onto" > "$dotest/onto"
 319prev_head=`git-rev-parse HEAD^0`
 320echo "$prev_head" > "$dotest/prev_head"
 321
 322msgnum=0
 323for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
 324                        | @@PERL@@ -e 'print reverse <>'`
 325do
 326        msgnum=$(($msgnum + 1))
 327        echo "$cmt" > "$dotest/cmt.$msgnum"
 328done
 329
 330echo 1 >"$dotest/msgnum"
 331echo $msgnum >"$dotest/end"
 332
 333end=$msgnum
 334msgnum=1
 335
 336while test "$msgnum" -le "$end"
 337do
 338        call_merge "$msgnum"
 339        continue_merge
 340done
 341
 342finish_rb_merge